﻿@using LAP.DomainModels.Models;
@{
    List<WorkingHourModel> WorkingHours = ViewBag.WorkingHours;
}
<link href="~/css/jquery.timepicker.css" rel="stylesheet" />
<div class="calendar-setting-control">
    @foreach (var item in WorkingHours)
    {
        <label>
            <input type="checkbox" class="d-none" id="checkbox-@item.Day.ToLower()" @(item.Active?"checked":"")>
            <span class="btn btn-icon btn-secondary btn-circle btn-xs mr-2" data-toggle="tooltip" data-original-title="@item.Day">@item.Day.Substring(0,1)</span>
        </label>
    }
    <div class="d-flex">
        <div class="w-300px">
            <div class="mt-5">
                @foreach (var item in WorkingHours)
                {
                    <div class="@(item.Active?"d-flex":"") align-items-center my-2 @(item.Active?"":"d-none")" id="row-@item.Day.ToLower()">
                        <div class="w-150px">@item.Day</div>
                        <div class="input-group input-group-solid w-190px timepicker-control" id="timpicker-@item.Day">
                            <input type="text" class="form-control form-control-xs calendar-timepicker time start" value="@item.StartTime" maxlength="8">
                            <div class="input-group-append"><span class="input-group-text">to</span></div>
                            <input type="text" class="form-control form-control-xs calendar-timepicker time end" value="@item.EndTime" maxlength="8">
                        </div>
                    </div>
                }
            </div>
        </div>
        <div class="ml-10 mt-5">
            <button type="button" class="btn btn-link-primary" id="copy-time"><i class="icon-xl la la-copy text-primary"></i> Copy to all</button>
        </div>
    </div>
</div>
<script src="~/lib/jquery.timepicker.min.js"></script>
<script>
    $("[id^='timpicker-']").each(function () {
        $(this).find('.calendar-timepicker').timepicker({
            'timeFormat': 'h:i A',
            'forceRoundTime': true
        });
    });
    $("[id^='checkbox-']").change(function (e) {
        var id = e.target.id.replace("checkbox-", "");
        if (e.target.checked)
            $(`#row-${id}`).removeClass("d-none").addClass("d-flex");
        else {
            $(this).prop("checked", true);
            var checkedLength = $("[id^='checkbox-']:checked").length;
            if (checkedLength > 1) {
                $(`#row-${id}`).addClass("d-none").removeClass("d-flex");
                $(this).prop("checked", false);
            }
            else
                _showFormMessage("calendar_setting_form", "warning", "You can't remove all days", "fas fa-exclamation-triangle");
        }
    });
    var getWorkingHours = function () {
        var workingHours = [];
        $("[id^='timpicker-']").each(function () {
            var visible = $(this).is(":visible");
            var day = $(this).attr("id").replace("timpicker-", "");
            var start = $(this).find(".start").val();
            var end = $(this).find(".end").val();
            if (visible && start == end)
                $(this).addClass("invalid-time-range");
            else
                workingHours.push({ Day: day, StartTime: start, EndTime: end, Active: visible });
        });
        return workingHours;
    }
    $(".start,.end").on('focusin', function () {
        $(this).data('value', $(this).val());
    }).on('change', function (e) {
        var parent = $(this).parent();
        if (!e.target.value) {
            var oldValue = $(this).data("value");
            $(this).val(oldValue);
        }
        if ($(this).hasClass("start")) {
            var startTime = parent.find(".start").timepicker('getTime');
            var minTime = moment(startTime).add(30, 'minutes').format('hh:mm A');
            setTimeout(function () {                
                parent.find('.end').timepicker({
                    'timeFormat': 'h:i A',
                    'forceRoundTime': true,
                    'minTime': minTime,
                    'maxTime': '11:30 PM'
                });
                parent.find('.end').val(minTime);
            }, 0);
        }
    });
    $("#copy-time").click(function () {
        var startTime = $(".start:visible:first").val();
        var endTime = $(".end:visible:first").val();
        $(".start").val(startTime);
        $(".end").val(endTime);
    });
    //$(".start").change();
</script>
<style>
    .calendar-setting-control .form-control,
    .calendar-setting-control .input-group-append .input-group-text {
        border: none !important;
    }

    .calendar-setting-control .input-group.input-group-solid:not(.invalid-time-range) {
        border: solid 1px #adb5bd !important;
    }

    .invalid-time-range {
        border: solid 1px #f64e60 !important;
    }

    .calendar-setting-control .input-group.input-group-solid {
        background-color: unset !important;
    }

    .calendar-setting-control input + span {
        font-size: 10px;
    }

    .calendar-setting-control input:checked + span {
        color: #ffffff !important;
        background: #3699FF !important
    }
</style>
